unit Lfunc;

interface
 uses
 SysUtils, Math;

type
 Complex = record
            re,im: Extended
           end;

function AddC (x,y: Complex): Complex;  //  
function SubC (x,y: Complex): Complex;  //  
function MulC (x,y: Complex): Complex;  //  
function DivC (x,y: Complex): Complex;  //  
function Sign(Arg1,Arg2 :Extended):Extended;   //   Arg2  |Arg1|
function IntSign(Arg1,Arg2 :Integer):Integer;  //   Arg2  |Arg1|
function AMax0(Arg1,Arg2 :Integer):Extended;   //  
function EMax1(Arg1,Arg2 :Extended):Extended;  //  
function Max0(Arg1,Arg2 :Integer):Integer;     //  
function Max1(Arg1,Arg2 :Extended):Integer;    //  
function AMin0(Arg1,Arg2 :Integer):Extended;   //  
function EMin1(Arg1,Arg2 :Extended):Extended;  //  
function Min0(Arg1,Arg2 :Integer):Integer;     //  
function Min1(Arg1,Arg2 :Extended):Integer;    //  
function IDim(Arg1,Arg2 :Integer):Integer;     //   : Arg1 - Min(Arg1,Agr2)
function EDim(Arg1,Arg2 :Extended):Extended;   //   : Arg1 - Min(Arg1,Agr2)
function Emod(Arg1,Arg2 :Extended):Extended;   //  
function Cabs(Arg :Complex):Extended;          //  
function Creal(Arg :Complex):Extended;         //   
function Aimag(Arg :Complex):Extended;         //   
function Conjg(Arg :Complex):Complex;          //    
function Cmplx(Arg1,Arg2 :Extended):Complex;   //    
function Cexp(Arg :Complex):Complex;           //
function Clog(Arg :Complex):Complex;           // 
function Csqrt(Arg :Complex):Complex;          // 
function Csin(Arg :Complex):Complex;           // 
function Ccos(Arg :Complex):Complex;           // 
function Cpower(Arg :Complex; N :Integer):Complex; //   

const
 _i_: Complex = (re: 0; im: 1);

implementation

function AddC (x,y: Complex): Complex;
//  
begin
 Result.re := x.re + y.re;
 Result.im := x.im + y.im;
end;
//**************************************
function SubC (x,y: Complex): Complex;
//  
begin
 Result.re := x.re - y.re;
 Result.im := x.im - y.im;
end;
//**************************************
function MulC (x,y: Complex): Complex;
//  
begin
 Result.re := x.re * y.re - x.im * y.im;
 Result.im := x.re * y.im + x.im * y.re;
end;
//**************************************
function DivC (x,y: Complex): Complex;
//  
var
 z  :Real;
begin
 z := sqr(y.re) + sqr(y.im);
 try //     z=0
  Result.re := (x.re * y.re + x.im * y.im) / z;
  Result.im := (x.re * y.im - x.im * y.re) / z;
 except
  Result.re := 1.1e309;
  Result.im := 1.1e309;
 end
end;
//**********************************************
function Sign(Arg1,Arg2 :Extended):Extended;
begin
 if ( Arg2>=0 )
  then if ( Arg1>=0 )
        then Result := Arg1
        else Result := -Arg1
  else if ( Arg1>=0 )
        then Result := -Arg1
        else Result := Arg1;
end;
//****************************************************
function IntSign(Arg1,Arg2 :Integer):Integer;
//   Arg2  |Arg1|
begin
 if ( Arg2>=0 )
  then if ( Arg1>=0 )
        then Result := Arg1
        else Result := -Arg1
  else if ( Arg1>=0 )
        then Result := -Arg1
        else Result := Arg1;
end;
//****************************************************
function AMax0(Arg1,Arg2 :Integer):Extended;
//  
begin
 if ( Arg1>=Arg2 )
        then Result := Arg1
        else Result := Arg2;
end;
//****************************************************
function EMax1(Arg1,Arg2 :Extended):Extended;
//  
begin
 if ( Arg1>=Arg2 )
        then Result := Arg1
        else Result := Arg2;
end;
//****************************************************
function Max0(Arg1,Arg2 :Integer):Integer;
//  
begin
 if ( Arg1>=Arg2 )
        then Result := Arg1
        else Result := Arg2;
end;
//****************************************************
function Max1(Arg1,Arg2 :Extended):Integer;
//  
begin
 if ( Arg1>=Arg2 )
        then Result := Trunc(Arg1)
        else Result := Trunc(Arg2);
end;
//****************************************************
function AMin0(Arg1,Arg2 :Integer):Extended;
//  
begin
 if ( Arg1<=Arg2 )
        then Result := Arg1
        else Result := Arg2;
end;
//****************************************************
function EMin1(Arg1,Arg2 :Extended):Extended;
//  
begin
 if ( Arg1<=Arg2 )
        then Result := Arg1
        else Result := Arg2;
end;
//****************************************************
function Min0(Arg1,Arg2 :Integer):Integer;
//  
begin
 if ( Arg1<=Arg2 )
        then Result := Arg1
        else Result := Arg2;
end;
//****************************************************
function Min1(Arg1,Arg2 :Extended):Integer;
//  
begin
 if ( Arg1<=Arg2 )
        then Result := Trunc(Arg1)
        else Result := Trunc(Arg2);
end;
//****************************************************
function IDim(Arg1,Arg2 :Integer):Integer;
//   
begin
 Result := Arg1 - Min0(Arg1,Arg2);
end;
//****************************************************
function EDim(Arg1,Arg2 :Extended):Extended;
//   
begin
 Result := Arg1 - EMin1(Arg1,Arg2);
end;
//****************************************************
function Cabs(Arg :Complex):Extended;
//  
begin
 Result := Sqrt(IntPower(Arg.re,2) + IntPower(Arg.im,2));
end;
//****************************************************
function Creal(Arg :Complex):Extended;
//   
begin
 Result := Arg.re;
end;
//****************************************************
function Aimag(Arg :Complex):Extended;
//   
begin
 Result := Arg.im;
end;
//****************************************************
function Conjg(Arg :Complex):Complex;
//    
begin
 Result.re :=  Arg.re;
 Result.im := -Arg.im;
end;
//****************************************************
function Cmplx(Arg1,Arg2 :Extended):Complex;
//    
begin
 Result.re :=  Arg1;
 Result.im :=  Arg2;
end;
//****************************************************
function Cexp(Arg :Complex):Complex;
//: e(Arg)=e(x+iy)=e(x)(cos(y)+isin(y))=e(x)*cos(y) + ie(x)*sin(y)
begin
 Result.re :=  Exp(Arg.re) * Cos(Arg.im);
 Result.im :=  Exp(Arg.re) * Sin(Arg.im);
end;
//****************************************************
function Clog(Arg :Complex):Complex;
// : ln(Arg)=ln(x+iy)=ln|x+iy| + iarg(x+iy)=Ln(Sqrt(Sqr(x)+Sqr(y))) + iArcTan2(y,x)
begin
 Result.re :=  Ln(Sqrt(Sqr(Arg.re)+Sqr(Arg.im)));
 Result.im :=  ArcTan2(Arg.im,Arg.re);
end;
//****************************************************
function Csqrt(Arg :Complex):Complex;
// : (Arg)**1/2=(x+iy)**1/2=Sqrt(Sqrt(Sqr(x)+Sqr(y)))*Cos(ArcTan2(y,x)/2) + iSqrt(Sqrt(Sqr(x)+Sqr(y)))*Sin(ArcTan2(y,x)/2)
begin
 Result.re :=  Sqrt(Sqrt(Sqr(Arg.re)+Sqr(Arg.im)))*Cos(ArcTan2(Arg.im,Arg.re)/2);
 Result.im :=  Sqrt(Sqrt(Sqr(Arg.re)+Sqr(Arg.im)))*Sin(ArcTan2(Arg.im,Arg.re)/2);
end;
//****************************************************
function Csin(Arg :Complex):Complex;
// : sin(Arg)=sin(z)=(e(iz)-e(-iz))/2i    
var
 vz1,vz2 : Complex;
const
 _0: Complex = (re: 0; im: 0);
 _2: Complex = (re: 2; im: 0);
begin
 vz1 := MulC(_i_,Arg); //iz
 vz2 := SubC(_0,vz1);  //-iz
 Result :=  DivC(SubC(Cexp(vz1),Cexp(vz2)),MulC(_2,_i_));
end;
//****************************************************
function Ccos(Arg :Complex):Complex;
// : cos(Arg)=cos(z)=(e(iz)+e(-iz))/2    
var
 vz1,vz2 : Complex;
const
 _0: Complex = (re: 0; im: 0);
 _2: Complex = (re: 2; im: 0);
begin
 vz1 := MulC(_i_,Arg); //iz
 vz2 := SubC(_0,vz1);  //-iz
 Result :=  DivC(AddC(Cexp(vz1),Cexp(vz2)),_2);
end;
//****************************************************
function Cpower(Arg :Complex; N :Integer):Complex;
//   : Arg**N=(x+iy)**N=|x+iy|**N * e(iN)=
// Sqrt(Sqr(x)+Sqr(y))**N * ( Cos(N*ArcTan2(y,x)) + iSin(N*ArcTan2(y,x)) )
begin
 Result.re := IntPower(Sqrt(Sqr(Arg.re)+Sqr(Arg.im)),N) * Cos(N*ArcTan2(Arg.im,Arg.re));
 Result.im := IntPower(Sqrt(Sqr(Arg.re)+Sqr(Arg.im)),N) * Sin(N*ArcTan2(Arg.im,Arg.re));
end;
//****************************************************
function Emod(Arg1,Arg2 :Extended):Extended;
//  
begin
// if ( arg2=0.0 )
//  then Result := 0
//  else Result := Arg1 -(Int(arg1 / arg2 ) * arg2);
 Result := Arg1 -(Int(arg1 / arg2 ) * arg2);
end;
//****************************************************
{
procedure UtDiagn(Mesg :String);
//    
var
FileRes: TextFile; //    
begin
AssignFile(FileRes, 'NAL_DIAG' + '.res');  //  
Rewrite(FileRes);                          //    
Write(FileRes,Mesg);                       //   
CloseFile(FileRes);                        // 
end;
//****************************************************
procedure UtRes(Fname :String; Mesg :String);
//    
var
FileRes: TextFile; //    
begin
AssignFile(FileRes, Fname + '.res');       //  
Rewrite(FileRes);                          //    
Write(FileRes,Mesg);                       //   
CloseFile(FileRes);                        // 
end;
//****************************************************
}
end.


